diff -Naur --exclude=CVS --exclude=configs linux/include/hpc/protocol.h linux-openmosix/include/hpc/protocol.h
--- linux/include/hpc/protocol.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/hpc/protocol.h	2003-02-23 19:00:38.000000000 +0100
@@ -0,0 +1,565 @@
+/* changes since Feb 12, 2002 copyright by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ * Author(s): Amnon Shiloh, Oren Laadan, Moshe Bar
+ */
+#ifndef _MOS_PROTOCOL_H
+#define _MOS_PROTOCOL_H
+#ifdef CONFIG_MOSIX
+#ifdef __KERNEL__
+
+#include <linux/signal.h>
+#include <linux/resource.h>
+#include <linux/elf.h>
+
+#define	EDIST	EDOM	/* MOSIX general error-code, that is otherwise */
+			/* rarely-if-ever returned by kernel */
+
+struct mosix_addr {
+	struct sockaddr saddr;
+};
+
+
+/* structures passed between DEPUTY and REMOTE: */
+
+struct mig_request_h
+{
+	long version;
+	short reason;
+	short topology;
+	int personality;
+	int wp_works_ok;
+	int pages_sent;
+	int request_type;
+	int has_dfsa;
+};
+
+enum contact_type
+{
+	FROM_DEPUTY, DEPUTY_PROBE, FROM_REMOTE
+};
+
+struct please_migrate_h
+{
+	int reason;
+	int to;
+	struct mosix_addr ma;
+};
+
+struct mmap_parameters_h
+{
+	unsigned long addr;
+	int fixed;
+	unsigned long len;
+	unsigned long flags;
+	unsigned long pgoff;
+	int origin;
+	struct file *fp;
+	struct dentry *dp;
+	uint64_t uniq;
+	off_t isize;
+	nopage_t nopage;
+};
+
+struct brk_parameters_h
+{
+	unsigned long addr;
+	unsigned long len;
+};
+
+struct munmap_parameters_h
+{
+	unsigned long addr;
+	size_t len;
+};
+
+struct mprotect_parameters_h
+{
+	unsigned long addr;
+	size_t len;
+	unsigned long prot;
+};
+
+struct setupframe_parameters_h
+{
+	unsigned long sig;
+	unsigned long flags;
+	__sighandler_t handler;
+	void (*restorer)(void);
+	sigset_t set;
+	struct siginfo info;
+	unsigned long ss_sp;
+	size_t ss_size;
+};
+
+struct restore_sigcontext_ret_h
+{
+	int result;
+	int eax;
+};
+
+struct prequest_h
+{
+	char command;
+	int param;
+	int param2;
+	int len;
+};
+
+struct prequest_reply_h
+{
+	int reply;
+	int error;
+	int datalen;
+};
+
+struct user_copy_h
+{
+	void *addr;
+	unsigned int size;
+	char verify;
+};
+
+struct strnlen_user_h
+{
+	char *addr;
+	long len;
+};
+
+struct user_csum_copy_h
+{
+	void *addr;
+	unsigned int len;
+	int sum;
+};
+
+struct user_csum_copy_ret_h
+{
+	unsigned int newsum;
+	unsigned int error;
+};
+
+struct asig_h
+{
+	unsigned int sigs;
+	int nforced;
+};
+
+struct syscall_h
+{
+	int n;
+	unsigned int args[6];
+	int simple_data_type;
+	unsigned long simple_data_addr;
+	int simple_data_len;
+	int simple_data_actual;
+};
+
+struct syscall_ret_h
+{
+	long ret;
+	unsigned long deputytime;
+	unsigned long simple_data_addr;
+	int simple_data_len;	/* -1 = complex data */
+};
+
+struct bring_page_h
+{
+	struct file *fp;
+	unsigned long offset;
+	nopage_t nopage;
+};
+
+struct page_ret_h
+{
+	int ret;
+	unsigned long deputytime;
+};
+
+struct rlimit_h
+{
+	int resource;
+	struct rlimit limit;
+};
+
+struct execve_counts_h
+{
+	char **argp;
+	char **envp;
+};
+
+struct execve_counts_ret_h
+{
+	int argc;
+	int envc;
+};
+
+struct execve_bring_strings_h
+{
+	unsigned long p;
+	char *filename;
+	char **envp;
+	int envc;
+	char **argp;
+	int argc;
+};
+
+struct execve_bring_strings_ret_h
+{
+	unsigned long p;
+	unsigned long exec;
+	int pgno;
+	int len;
+	int result;
+};
+
+struct execve_more_strings_h
+{
+	int pgno;
+	int len;
+};
+
+struct execve_setup_args_h
+{
+	int create;
+	int pgno;
+	int len;
+	int how;
+	int p;
+	int loader;
+	int exec;
+	int argc;
+	int envc;
+	unsigned long personality;
+};
+
+struct execve_setup_args_ret_h
+{
+	unsigned long p;
+	unsigned long loader;
+	unsigned long exec;
+	int reply;
+	unsigned long start_stack;
+};
+
+struct execve_exec_mmap_ret_h
+{
+	int result;
+	char comm[16];
+};
+
+struct execve_elf_setup_h
+{
+	char *p;
+	int argc;
+	int envc;
+	int hasexec;
+	unsigned long exec_e_phoff;
+	unsigned long exec_e_phnum;
+	unsigned long exec_e_entry;
+	unsigned long addr;
+	unsigned long load_bias;
+	unsigned long interp_load_addr;
+	int ibcs;
+	struct elf_tables_extras extras;
+	int add_arg_start;
+	unsigned long elf_brk;
+	unsigned long end_code;
+	unsigned long start_code;
+	unsigned long start_data;
+	unsigned long end_data;
+	unsigned long elf_bss;
+	unsigned long personality;
+};
+
+struct execve_fix_elf_aout_h
+{
+	unsigned bss;
+	unsigned data;
+	unsigned text;
+};
+
+struct list_vmas_ret_h
+{
+	int n;
+	unsigned long argstart;
+	unsigned long argend;
+};
+
+struct fork_h
+{
+	unsigned long usp;
+	int do_forkmigrate;
+	int pid;
+	pid_t tgid;
+};
+
+struct mm_stats_h
+{
+	unsigned long start_code, end_code, start_data, end_data;
+	unsigned long start_brk, brk, start_stack;
+	unsigned long arg_start, arg_end, env_start, env_end;
+};
+
+struct disclosure_h
+{
+	uid_t uid;
+	gid_t gid;
+	pid_t pgrp;
+	pid_t session;
+	char disclosure;
+	char comm[16];
+	pid_t tgid;
+};
+
+struct mig_misc_h
+{
+	unsigned long ptrace;
+	unsigned long dflags;
+	long debugreg[8];
+	long nice;
+	kernel_cap_t caps;
+	unsigned long it_prof_value, it_prof_incr, it_virt_value, it_virt_incr;
+	struct pt_regs regs;
+	/* segment registers. FIXME: need to go inside regs */
+	unsigned long fs;
+	unsigned long gs;
+	struct rlimit rlim_cpu, rlim_data, rlim_stack, rlim_rss, rlim_as;
+#ifdef CONFIG_MOSIX_DFSA
+	struct rlimit rlim_nofile, rlim_fsz;
+#endif /* CONFIG_MOSIX_DFSA */
+	char stay;
+	unsigned short deppe;
+	unsigned short deputy_regs;
+	u64 passedtime;
+	u16 deccycle;
+	s16 decay;
+	u8 dpolicy;
+	pid_t mypid;
+	struct asig_h asig;
+	struct disclosure_h info;
+	int nmigs;
+	int pagecredit;
+	int lastxcpu;
+	__u32 features[NCAPINTS];
+	u64 tscval;
+	struct opcost depcost[MAX_MOSIX_TOPOLOGY];
+	int depspeed;
+};
+
+struct decay_h
+{
+	int policy;
+	int deccycle;
+	int decay;
+};
+
+struct aload_h
+{
+	int aload;
+	int freepages;
+#ifdef CONFIG_MOSIX_TOPOLOGY
+	struct mfs_cost mfscosts[MAX_MOSIX_TOPOLOGY];
+#endif /* CONFIG_MOSIX_TOPOLOGY */
+};
+
+#ifdef CONFIG_MOSIX_DFSA
+struct read_yourself_h
+{
+	int dfsano;
+	loff_t off;
+	unsigned long addr;
+	unsigned long len;
+	int infolen;
+};
+#endif /* CONFIG_MOSIX_DFSA */
+
+/* COMMAND CLASSES: */
+
+#define	DEP_FLG	0x100
+#define	MIG_FLG	0x200
+#define	REPLY	0x400
+#define	ANYTIME	0x800
+#define	USERMODE 0x1000
+#ifdef CONFIG_MOSIX_DFSA
+#define	DFSA_NOUPDATE	0x2000
+#else
+#define	DFSA_NOUPDATE	0
+#endif /* CONFIG_MOSIX_DFSA */
+
+/* COMMANDS: */
+
+#define	DEP_USERMODE		(DEP_FLG|0x00)
+#define	DEP_SYNC		(DEP_FLG|0x01)
+#define	DEP_NOTHING		(DEP_FLG|0x02)
+#define	DEP_MMAP		(DEP_FLG|0x03)
+#define	DEP_MUNMAP		(DEP_FLG|0x04)
+#define	DEP_LISTHOLD		(DEP_FLG|0x05)
+#define	DEP_SETUPFRAME		(DEP_FLG|0x06)
+#define	DEP_NICE		(DEP_FLG|0x07)
+#define	DEP_CPAS		(DEP_FLG|0x08)
+#define	DEP_RESTORESIGCONTEXT	(DEP_FLG|0x09)
+#define	DEP_PREQUEST		(DEP_FLG|0x10)
+#define	DEP_COPY_FROM_USER	(DEP_FLG|0x11)
+#define	DEP_COPY_TO_USER	(DEP_FLG|0x12)
+#define	DEP_CLEAR_USER		(DEP_FLG|0x13)
+#define	DEP_STRNCPY_FROM_USER	(DEP_FLG|0x14)
+#define	DEP_STRNLEN_USER	(DEP_FLG|0x15)
+#define	DEP_VERIFY_WRITE	(DEP_FLG|0x16)
+#define	DEP_RLIMIT		(DEP_FLG|0x17)
+#define	DEP_TAKEURGENT		(DEP_FLG|0x18)
+#define	DEP_RUSAGE		(DEP_FLG|0x19)
+#define	DEP_EXECVE_COUNTS	(DEP_FLG|0x20)
+#define	DEP_BRING_STRINGS	(DEP_FLG|0x21)
+#define	DEP_SETUP_ARGS		(DEP_FLG|0x22)
+#define	DEP_EXEC_MMAP		(DEP_FLG|0x23)
+#define	DEP_DUMP_THREAD		(DEP_FLG|0x24)
+#define	DEP_INIT_AOUT_MM	(DEP_FLG|0x25)
+#define	DEP_ELF_SETUP		(DEP_FLG|0x26)
+#define	DEP_FIX_ELF_AOUT	(DEP_FLG|0x27)
+#define	DEP_LIST_VMAS		(DEP_FLG|0x28)
+#define	DEP_PLEASE_FORK		(DEP_FLG|0x29)
+#define DEP_CONSIDER		(DEP_FLG|0x30)
+#define	DEP_PERSONALITY		(DEP_FLG|0x31)
+#define	DEP_BRING_ME_REGS	(DEP_FLG|0x32)
+#define	DEP_CSUM_COPY_FROM_USER	(DEP_FLG|0x33)
+#define	DEP_DUMP_FPU		(DEP_FLG|0x34)
+#define	DEP_COME_BACK		(DEP_FLG|0x35)
+#define DEP_PLEASE_MIGRATE	(DEP_FLG|0x36)
+#define	DEP_CACHE_READ_DATA	(DEP_FLG|0x37)
+#define	DEP_DATA_TO_USER	(DEP_FLG|0x38)
+#define	DEP_UPDATE_DECAY	(DEP_FLG|0x39)
+#define	DEP_UPDATE_LOCK		(DEP_FLG|0x40)
+#define	DEP_PSINFO		(DEP_FLG|0x41)
+#define	DEP_OPCOSTS		(DEP_FLG|0x42)
+#define	DEP_MPROTECT		(DEP_FLG|0x43)
+#define	DEP_BRK			(DEP_FLG|0x44)
+#define	DEP_CAPS		(DEP_FLG|0x45)
+#define	DEP_INFO		(DEP_FLG|0x46)
+#define	DEP_UPDATE_MIGFILTER	(DEP_FLG|0x47)
+#define	DEP_UPDATE_MIGPOLICY	(DEP_FLG|0x48)
+#define	DEP_UPDATE_MIGNODES	(DEP_FLG|0x49)
+#define DEP_UPDATE_MIGGROUP	(DEP_FLG|0x50)
+#ifdef CONFIG_MOSIX_DFSA
+#define	DEP_DFSA_CHANGES	(DEP_FLG|0x80)
+#define	DEP_DFSA_CLEAR		(DEP_FLG|0x81)
+#define	DEP_READ_YOURSELF	(DEP_FLG|0x82)
+#endif /* CONFIG_MOSIX_DFSA */
+
+#define	REM_NOTHING		(ANYTIME|0x01)
+#define	REM_PAGE		(ANYTIME|DFSA_NOUPDATE|0x02)
+#define	REM_MORESTRINGS		(ANYTIME|0x03)
+#define	REM_BRING_ME_REGS	(ANYTIME|0x04)
+#define	REM_GETALOAD		(ANYTIME|0x05)
+#define	REM_GETTSC		(ANYTIME|0x06)
+
+#define	REM_NULLMSG		0x01
+#define	REM_ASIG		0x02
+#define	REM_SYSCALL_TRACE	0x03
+#define	REM_SYSCALL		0x04
+#define REM_BRING_ME_HOME	0x05
+#define	REM_BRING_ME_TO		0x06
+#define	REM_CONSIDERING		0x07
+#define	REM_MUST_COME_HOME	0x08
+#define	REM_CONNECT_TO		0x09
+
+#define MIG_REQUEST		(MIG_FLG|0x01)
+
+#define	MIG_MM_STATS		(MIG_FLG|0x10)
+#define	MIG_MM_AREA		(MIG_FLG|0x11)
+#define	MIG_PAGE		(MIG_FLG|0x12)
+#define	MIG_FP			(MIG_FLG|0x13)
+#define	MIG_XFP			(MIG_FLG|0x14)
+#define	MIG_LDT			(MIG_FLG|0x15)
+#define	MIG_MISC		(MIG_FLG|0x16)
+#define	MIG_NOT_COMING		(MIG_FLG|0x17)
+
+/* routines on the DEPUTY side of the protocol: */
+
+extern int deputy_request(int, void *, int, void *, int, int, void **, int);
+extern int deputy_wait(int, void **, int *);
+extern int deputy_reply(int, void *, int, void *, int, int, int);
+extern int deputy_handle_interim_request(int, void *, int);
+extern void deputy_syscall(struct syscall_h *, int);
+extern void deputy_rusage(int);
+extern void deputy_add_rusage(struct rusage *);
+extern void deputy_analyse_remote_signals(struct asig_h *);
+extern int deputy_bring_page(struct bring_page_h *);
+extern int deputy_tsc(void);
+extern int deputy_more_strings(struct execve_more_strings_h *);
+extern int deputy_bring_me_regs(unsigned long *);
+extern void deputy_inform_remote_of_overheads(void);
+
+/* routines on the REMOTE side of the protocol: */
+
+extern int remote_request(int, void *, int, void *, int, int, void **, int);
+extern void wait_for_permission_to_continue(void);
+extern int remote_deputy_has_something_for_us(struct task_struct *);
+extern void inform_deputy_of_urgent(void);
+extern void transfer_signals_to_deputy(unsigned int, siginfo_t *, int);
+extern void absorb_deptime(unsigned long);
+extern int remote_rusage(int *);
+extern int remote_execve_counts(struct execve_counts_h *);
+extern int remote_bring_strings(struct execve_bring_strings_h *);
+extern int remote_setup_args(struct execve_setup_args_h *);
+extern int remote_exec_mmap(void);
+extern int remote_urgent(void);
+extern int remote_readpage(struct file *, struct page *);
+extern int remote_dump_thread(void);
+extern int remote_init_aout_mm(struct exec *);
+extern int remote_elf_setup(struct execve_elf_setup_h *);
+extern int remote_fix_elf_aout(struct execve_fix_elf_aout_h *);
+extern int remote_list_vmas(void);
+extern int remote_fork(struct fork_h *);
+extern int remote_personality(unsigned long *);
+extern int remote_prequest(struct prequest_h *);
+extern int remote_mmap(struct mmap_parameters_h *, int);
+extern int remote_brk(struct brk_parameters_h *);
+extern int remote_munmap(struct munmap_parameters_h *);
+extern int remote_mprotect(struct mprotect_parameters_h *);
+extern int remote_come_back(void *);
+extern int remote_goto_remote(void *);
+extern int remote_copy_from_user(struct user_copy_h *);
+extern int remote_copy_to_user(struct user_copy_h *);
+extern int remote_data_to_user(struct user_copy_h *);
+extern int remote_clear_user(struct user_copy_h *);
+extern int remote_strncpy_from_user(struct user_copy_h *);
+extern int remote_strnlen_user(struct strnlen_user_h *);
+extern int remote_verify_write(struct user_copy_h *);
+extern int remote_csum_copy_from_user(struct user_csum_copy_h *);
+extern int remote_csum_copy_to_user(struct user_csum_copy_h *);
+extern int remote_report_files(void);
+extern int remote_setup_frame(struct setupframe_parameters_h *);
+extern int remote_nice(long *);
+extern int remote_caps(kernel_cap_t *);
+extern int remote_depcosts(void *);
+extern int remote_restore_sigcontext(struct sigcontext **);
+extern int remote_bring_me_regs(unsigned long *);
+extern int remote_dump_fpu(void);
+extern int remote_consider(int *);
+extern int remote_setdecay(struct decay_h *);
+extern int remote_set_lock(int *);
+extern int remote_set_migfilter(int *);
+extern int remote_set_migpolicy(int *);
+extern int remote_set_mignodes(uint32_t *);
+extern int remote_set_miggroup(int *);
+extern int remote_psinfo(void);
+#ifdef CONFIG_MOSIX_DFSA
+extern int remote_receive_dfsachanges(int *);
+extern int remote_read_yourself(struct read_yourself_h *);
+#endif /* CONFIG_MOSIX_DFSA */
+extern int remote_rlimit(struct rlimit_h *);
+extern int remote_updinfo(struct disclosure_h *);
+extern void remote_do_updinfo(struct disclosure_h *);
+extern void remote_fill_rusage(struct rusage *, int);
+
+/* routines used by both sides of the protocol: */
+
+extern unsigned int which_regs_to_send(void);
+extern void regs_were_sent(void);
+
+#endif /*__KERNEL__*/
+#endif /* CONFIG_MOSIX */
+#endif
diff -Naur --exclude=CVS --exclude=configs linux/include/hpc/request.h linux-openmosix/include/hpc/request.h
--- linux/include/hpc/request.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/hpc/request.h	2002-06-24 09:22:32.000000000 +0200
@@ -0,0 +1,120 @@
+/*
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * THIS  SOFTWARE  IS  PROVIDED IN ITS  "AS IS"  CONDITION, WITH NO WARRANTY
+ * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
+ * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
+ */
+/*
+ * Author(s): Amnon Shiloh.
+ */
+#ifndef _MOS_REQUEST_H
+#define _MOS_REQUEST_H
+#ifdef CONFIG_MOSIX
+
+struct prequest
+{
+	struct prequest *rnext;		/* next in request chain */
+	struct prequest *cnext;		/* caller chain */
+	volatile char rflags;		/* coordination flags - see below */
+	char command;			/* ... */
+	int param;			/* optional parameter */
+	int param2;			/* optional parameter */
+	caddr_t ereply;		 	/* extended reply address */
+	int len;			/* optional extended reply length */
+	long reply;			/* reply, if only one longword */
+	wait_queue_head_t waitq;	/* who is waiting for the reply */
+};
+
+/* flags: */
+
+#define PR_WAITING	1       /* caller still waiting for the request */
+#define PR_DONE	 	2	/* request complete */
+#define PR_ERROR	4	/* request failed, reply contains errno */
+
+/* commands: */
+
+enum
+{
+PR_PROCFS_TASK_MEM = 1,
+PR_PROCFS_GET_ENV,
+PR_PROCFS_GET_ARG,
+PR_PROCFS_GET_STAT_PARTS,
+PR_PROCFS_GET_STATM,
+PR_PROCFS_MAP_INFO,
+PR_PROCFS_MEM_READ,
+PR_PROCFS_MEM_WRITE,
+PR_PROCFS_UPDATE_TIMES,
+PR_PROCFS_GET_EXE,
+PR_PTRACE_GET_STACK_LONG,
+PR_PTRACE_PUT_STACK_LONG,
+PR_PTRACE_GETREGS,
+PR_PTRACE_SETREGS,
+PR_PTRACE_PEEKUSER,
+PR_PTRACE_POKEUSER,
+PR_PTRACE_CONT,
+PR_PTRACE_SINGLE_STEP,
+PR_PTRACE_GETFPREGS,
+PR_PTRACE_SETFPREGS,
+PR_PTRACE_GETFPXREGS,
+PR_PTRACE_SETFPXREGS,
+PR_PTRACE_NOT_TRACED,
+#ifdef CONFIG_MOSIX_DFSA
+PR_DFSA_SYNCHRONIZE,
+#endif /* CONFIG_MOSIX_DFSA */
+};
+
+#define	SHOULD_ASK_PROCESS(p)	(p && (p->mosix.dflags & DDEPUTY) && (p != current || !(p->mosix.dflags & DINSCHED)))
+
+extern int request_process_arg2(struct task_struct *, void *, int, int, int);
+#define request_process(_t, _b, _c, _a) request_process_arg2(_t, _b, _c, _a, 0)
+extern char *request_process_to_buf_arg(struct task_struct *, char *, int, int);
+#define request_process_to_buf(_p,_b,_c) request_process_to_buf_arg(_p,_b,_c,0)
+
+extern char *fill_common_ps_info(int *);
+extern int pick_ps(struct task_struct *, struct prequest *);
+extern void store_common_ps_info(void);
+extern void stop_storing_common_ps_info(void);
+extern void process_requests(void);
+extern void discard_requests(void);
+extern void process_only_easy_requests(void);
+
+struct proc_remote_stat_parts
+{
+	unsigned long vsize, eip, esp;
+	long priority;
+	unsigned long rss, start_code, end_code, start_stack;
+	long processor;
+};
+
+/* routines in other parts of the kernel that are called by MOSIX: */
+
+extern int proc_pid_environ(struct task_struct *, char *);
+extern int proc_pid_cmdline(struct task_struct *, char *);
+extern char *task_mem(struct mm_struct *, char *);
+extern void proc_get_stat_parts(struct task_struct *, struct mm_struct *, struct proc_remote_stat_parts *);
+extern int proc_pid_statm(struct task_struct *, char *);
+struct vmamaps;
+extern int proc_list_maps(struct vmamaps *, int);
+extern void ref_mapped_files(struct vmamaps *, int);
+extern int get_stack_long(struct task_struct *, int);
+extern int put_stack_long(struct task_struct *, int, unsigned long);
+extern void ptrace_putregs(unsigned long *);
+extern void ptrace_getregs(unsigned long *);
+extern unsigned long ptrace_peekuser(long);
+extern void ptrace_pokeuser(long, long);
+extern void ptrace_cont(int);
+extern void ptrace_single_step(void);
+struct user_i387_struct;
+extern void ptrace_getfpregs(struct user_i387_struct *);
+extern void ptrace_setfpregs(struct user_i387_struct *);
+struct user_fxsr_struct;
+extern void ptrace_getfpxregs(struct user_fxsr_struct *);
+extern void ptrace_setfpxregs(struct user_fxsr_struct *);
+extern struct file *first_executable(void); 
+
+#endif /* CONFIG_MOSIX */
+#endif
diff -Naur --exclude=CVS --exclude=configs linux/include/hpc/routines.h linux-openmosix/include/hpc/routines.h
--- linux/include/hpc/routines.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/hpc/routines.h	2003-02-23 19:00:56.000000000 +0100
@@ -0,0 +1,232 @@
+/* Changes since Feb 12, 2002 copyright by Moshe Bar
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * THIS  SOFTWARE  IS  PROVIDED IN ITS  "AS IS"  CONDITION, WITH NO WARRANTY
+ * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
+ * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
+ */
+/*
+ * Author(s): Amnon Shiloh, Moshe Bar
+ */
+#ifndef _MOS_ROUTINES_H
+#define _MOS_ROUTINES_H
+#ifdef CONFIG_MOSIX
+
+#include <linux/stddef.h>
+
+/*
+ * a collection of routines in hpc/?*.c that are neither:
+ * 1) used by the rest of the kernel	 --> include/linux/hpc.h
+ * 2) in the communication package	 --> include/hpc/comm.h
+ * 3) part of the DEPUTY/REMOTE protocol --> include/hpc/protocol.h
+ * 4) related to prequests		 --> include/hpc/request.h
+ * 5) related to DFSA			 --> include/hpc/dfsa.h
+ */
+
+struct task_struct;
+struct mosixnet;
+
+/* task management: */
+
+extern int remote_need_while_asleep(struct task_struct *);
+extern int other_needs_while_asleep(void);
+extern void remote_run_while_asleep(void);
+extern void deputy_run_while_asleep(void);
+extern int remote_pre_usermode_actions(void);
+extern int local_pre_usermode_actions(void);
+extern void per_task_ack_mosix_state(void);
+extern char *desc_mostask(struct mosix_task *);
+extern void mosix_do_add_to_whereto(struct task_struct *, int);
+extern void common_daemon_setup(char *, int);
+extern void neutralize_my_load(int);
+extern void wait_for_mosix_configuration(int *);
+extern int obtain_mm(void);
+extern void sync_caps(void);
+
+/* load balancing: */
+
+extern void mosix_load_init(void);
+extern void load_balance(void);
+extern void mosix_clear_statistics(void);
+struct sonstats;
+extern void consider(int, struct sonstats *);
+extern int send_local_aload(int);
+extern int send_with_miginfo(int, void *, int);
+extern void mosix_local_syscall(void);
+extern void release_migrations(int);
+extern void changed_my_mind_and_staying(void);
+extern int balance_commit_mig(int, int);
+extern void info_someone_came_in(void);
+extern void end_coming_in(int);
+extern void add_statistics_to_ancesstor(struct task_struct *, struct task_struct *);
+extern void info_update_costs(void);
+extern void info_update_mfscosts(void);
+extern void load_balance(void);
+extern void memory_balance(void);
+extern void age_balancing(void);
+extern void unchoose_me(void);
+
+/* memory handling: */
+
+extern void init_mdp(void);
+extern void compute_freemem(void);
+extern int export_mem(void);
+extern int memory_badly_required(void);
+extern int memory_relief_quality(struct task_struct *, int);
+extern void memory_balance(void);
+
+/* information dissemination: */
+
+extern void init_mosconfig(void);
+extern int mosix_info_daemon(void *); 
+extern void info_init(void);
+extern void info_startup(void);
+extern void info_reconfig(void);
+struct mosix_info;
+struct loadinfo;
+extern int balance_get_load(int, struct loadinfo *);
+extern int balance_get_infos(int, int, struct mosix_info *, int);
+extern int balance_get_info(int, struct mosix_info *);
+extern void mosinfo_update_gateways(void);
+extern void this_machine_is_favourite(int);
+extern int mosix_mem_daemon(void *); 
+
+/* process migration: */
+
+struct mig_request_h;
+extern int mosix_mig_daemon(void *);
+extern int passto(int, int);
+extern int mosix_do_send_back_home(struct task_struct *);
+extern int mosix_do_go_home(int);
+extern void follow_whereto(void);
+extern int mig_migrate(int);
+extern void mig_set_lock(int);
+extern void mig_set_migfilter(int);
+extern void mig_set_migpolicy(int);
+extern void mig_set_mignodes(uint32_t);
+extern void mig_set_miggroup(int);
+extern int count_migrating_pages(void);
+extern void kickstart(void);
+extern int run_over_dirty_pages(int (*func)(unsigned long, int), int);
+extern void deputy_startup(void);
+extern int mig_send_request(int, int);
+extern int mig_recv_request(struct mig_request_h **);
+extern int mig_do_send(void);
+extern int mig_do_receive(void);
+
+/* deputy: */
+
+extern void deputy_main_loop(void);
+extern void undeputy(struct task_struct *);
+extern void deputy_async_requests(void);
+extern void mosix_clear_all_held_files(struct task_struct *);
+extern int fork_mosix_remote_files(struct task_struct *);
+extern void coordinate(int, int);
+extern long call_with_regs(void *, struct pt_regs *, struct pt_regs *);
+extern int task_maps_ip(struct task_struct *, struct inode *);
+extern void deputy_communication_failed(void);
+extern void deputy_die_on_communication(void) ATTRIB_NORET;
+
+/* remote: */
+
+extern int remote_wait(int, void **, int *);
+extern void wait_for_permission_to_continue(void);
+extern int remote_request(int, void *, int, void *, int, int, void **, int);
+extern long remote_standard_system_call(int, struct pt_regs *);
+extern struct file *get_remote_file(int, struct file *, struct dentry *, unsigned long long, off_t, nopage_t);
+extern void remote_disappear(void) __attribute__((noreturn));
+
+/* data cache: */
+
+struct syscall_h;
+struct syscall_ret_h;
+extern int copy_from_cache(char *, unsigned long, int, int *);
+extern int copy_to_cache(unsigned long, char *, int, int *);
+extern int zero_cache(char *, int, int *);
+extern int strlen_cache(char *, int *);
+extern int all_in_cache(unsigned long, unsigned int, int);
+extern int any_in_cache(unsigned long, unsigned int);
+extern int alloc_ucache(void);
+extern void free_ucache(void);
+extern void flush_ucache(void);
+extern void flush_read_cache(void);
+extern int ucache_ok(unsigned long, unsigned long, int);
+extern int remote_unpack_read_cache_data(struct syscall_ret_h *);
+extern void set_read_region(unsigned long, unsigned int);
+extern void set_write_region(unsigned long, unsigned int);
+extern char *construct_ucache_envelope(int *, int *, struct syscall_h *, char **);
+extern int open_ucache_envelope(struct syscall_h *);
+extern char *deputy_pack_read_cache_data(int *, struct syscall_ret_h *, char **);
+
+/* configuration: */
+
+extern int count_mosix_nodes(void); 
+extern int nth_node(int);
+extern int mos_to_ascii(int, char *, int);
+extern int mos_to_net(int, void *);
+extern int mymos_to_net(void *);
+extern int mosix_config_get_table(struct mosixnet **, int, int);
+extern int mosix_config_set_table(struct mosixnet *, int, int);
+extern int mosix_config_get_pe(void);
+extern int mosix_config_set_pe(int);
+extern int mosix_config_get_tentative_pe(void);
+extern int mosix_config_get_limit(void);
+extern int count_mosix_nodes(void);
+extern int config_get_status(int);
+extern int config_set_status(int);
+extern int i_am_in_a_wrong_place(void);
+extern void done_checking_conf(void);
+#ifdef CONFIG_MOSIX_FS
+extern int scan_mosix_nodes(int, int *, int *);
+#endif /* CONFIG_MOSIX_FS */
+
+/* statistics decay: */
+
+extern int decay_inherit(int);
+extern int decay_exec(int);
+extern int decay_execonce(int);
+extern int decay_set(int, int, int);
+extern int decay_get(int);
+extern void decay_clear(void);
+extern void deputy_update_remote_decay(void);
+extern void do_decay(void);
+extern void inc_decays(void);
+extern now_t time_now(void);
+#define	time_since(_when_)	(time_now() - (_when_))
+
+/* MOSIX administration: */
+
+extern int admin_get_mode(int);
+extern int admin_set_mode(int, int);
+extern int expel(int);
+extern int bring(void);
+extern void proc_update_costs(void);
+extern int my_mosix_status(void);
+extern void set_my_cpuspeed(void);
+
+/* debugging: */
+
+/* macros: */
+
+#define	MOSIX_TO_TASK(m) ((struct task_struct *)(((char *)m)-offsetof(struct task_struct,mosix)))
+
+#ifdef CONFIG_MOSIX_DFSA
+#define	URGENT_REMOTE_CONDITIONS(p)	((p)->mosix.whereto || \
+					process_told((p), DREQ_DFSASYNC))
+#else
+#define	URGENT_REMOTE_CONDITIONS(m)	((p)->mosix.whereto)
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX */
+
+#if MILLION % HZ
+#define ticks_to_ms(ticks)	(((int64_t)(ticks)) * MILLION / HZ)
+#define	ms_to_ticks(ms)		((ms) * HZ / MILLION)
+#else
+#define ticks_to_ms(ticks)	(((int64_t)(ticks)) * (MILLION / HZ))
+#define	ms_to_ticks(ms)		((ms) / (MILLION/HZ))
+#endif
+
+#endif
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/binfmts.h linux-openmosix/include/linux/binfmts.h
--- linux/include/linux/binfmts.h	2001-11-22 20:46:19.000000000 +0100
+++ linux-openmosix/include/linux/binfmts.h	2004-02-05 10:51:27.000000000 +0100
@@ -65,5 +65,12 @@
 #define change_ldt(a,b) setup_arg_pages(a,b)
 #endif
 
+#ifdef CONFIG_MOSIX
+extern void execve_remote_counts(char **, char **, int *, int *);
+extern int execve_remote_bring_strings(struct linux_binprm *, char **, char **);
+extern unsigned long *create_aout_tables(char *, struct linux_binprm *);
+extern int exec_mmap(void);
+#endif /* CONFIG_MOSIX */
+
 #endif /* __KERNEL__ */
 #endif /* _LINUX_BINFMTS_H */
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/capability.h linux-openmosix/include/linux/capability.h
--- linux/include/linux/capability.h	2001-11-22 20:46:19.000000000 +0100
+++ linux-openmosix/include/linux/capability.h	2004-02-05 10:51:27.000000000 +0100
@@ -348,6 +348,11 @@
 
 #define cap_is_fs_cap(c)     (CAP_TO_MASK(c) & CAP_FS_MASK)
 
+#ifdef CONFIG_MOSIX
+#define	REMOTE_CAPS	(CAP_FS_MASK | CAP_TO_MASK(CAP_LINUX_IMMUTABLE) | \
+						CAP_TO_MASK(CAP_SYS_RESOURCE))
+#endif /* CONFIG_MOSIX */
+
 #endif /* __KERNEL__ */
 
 #endif /* !_LINUX_CAPABILITY_H */
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/completion.h linux-openmosix/include/linux/completion.h
--- linux/include/linux/completion.h	2001-11-22 20:46:19.000000000 +0100
+++ linux-openmosix/include/linux/completion.h	2004-02-05 10:51:27.000000000 +0100
@@ -28,6 +28,9 @@
 }
 
 extern void FASTCALL(wait_for_completion(struct completion *));
+#ifdef CONFIG_MOSIX
+extern void FASTCALL(wait_for_completion_half_interruptible(struct completion *));
+#endif /* CONFIG_MOSIX */
 extern void FASTCALL(complete(struct completion *));
 
 #define INIT_COMPLETION(x)	((x).done = 0)
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/dcache.h linux-openmosix/include/linux/dcache.h
--- linux/include/linux/dcache.h	2002-11-29 00:53:15.000000000 +0100
+++ linux-openmosix/include/linux/dcache.h	2004-02-05 10:51:27.000000000 +0100
@@ -125,6 +125,10 @@
 					 */
 #define DCACHE_REFERENCED	0x0008  /* Recently used, don't discard. */
 
+#ifdef CONFIG_MOSIX_FS
+#define	DCACHE_NO_CACHE	      0x0010	/* do not hash, do not cache */
+#endif /* CONFIG_MOSIX_FS */
+
 extern spinlock_t dcache_lock;
 
 /**
diff -Naur --exclude=CVS --exclude=configs linux/include/linux/dfsa_interface.h linux-openmosix/include/linux/dfsa_interface.h
--- linux/include/linux/dfsa_interface.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/include/linux/dfsa_interface.h	2002-02-14 11:35:25.000000000 +0100
@@ -0,0 +1,69 @@
+/*
+ * Copyright (C) 2000, 2001, Amnon Barak (amnon@cs.huji.ac.il)
+ *
+ * Permission to use this software is hereby granted under the terms of the
+ * GNU General Public License, as published by the Free Software Foundation.
+ *
+ * THIS  SOFTWARE  IS  PROVIDED IN ITS  "AS IS"  CONDITION, WITH NO WARRANTY
+ * WHATSOEVER. NO LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING
+ * FROM THE USE OF THIS SOFTWARE WILL BE ACCEPTED.
+ */
+/*
+ * Author(s): Amnon Shiloh.
+ */
+/* DFSA definitions and functions required anywhere outside of MOSIX */
+#ifndef _MOS_DFSA_INTERFACE_H
+#define _MOS_DFSA_INTERFACE_H
+
+#ifdef CONFIG_MOSIX_DFSA
+
+/* update flags (dupdates): */
+
+#define	DFSA_UPDCRED	1	/* need to update credentials */
+#define	DFSA_UPDTABLE	2	/* need to update DFSA table */
+#define	DFSA_UPDCDIR	4	/* need to update current-directory */
+#define	DFSA_UPDMAX	8	/* need to update "max_fdset" */
+#define	DFSA_UPDCLOSE	16	/* need to update closed files */
+#define	DFSA_UPDOPEN	32	/* need to update opened files */
+#define	DFSA_UPDMODS	64	/* need to update modified files */
+#define	DFSA_UPDUSED	128	/* need to update the "used" bits */
+#define	DFSA_UPDSEL	256	/* need to update MFS node-selections */
+#define	DFSA_UPDUMASK	512	/* need to update umask */
+
+#define	DFSA_UPDATE	(DFSA_UPDCRED|DFSA_UPDTABLE|DFSA_UPDCDIR|DFSA_UPDMAX|\
+			 DFSA_UPDCLOSE|DFSA_UPDOPEN|DFSA_UPDMODS|DFSA_UPDUSED|\
+			 DFSA_UPDSEL|DFSA_UPDUMASK)
+
+#define CAN_DFSA(p)	((p)->fs && atomic_read(&(p)->fs->users) == 1 && \
+			!(p)->fs->altroot && \
+			(p)->files && atomic_read(&(p)->files->users) == 1 && \
+			(p)->fs->root == init_task.fs->root && \
+			(p)->fs->rootmnt == init_task.fs->rootmnt && \
+			!((p)->ptrace) && !(p->flags & PF_EXITING))
+
+/* adjust the following if any file-system requires more identifying bytes: */
+#define	MAX_IDENT_RECORD_LEN	20
+
+struct vfsmount;
+struct dentry;
+struct nameidata;
+struct file;
+
+void dfsa_init(void);
+int dfsa_setmnt(struct vfsmount *, int, unsigned long);
+int dfsa_option(char *, int *);
+void dfsa_close_file(int);
+void dfsa_open_file(int);
+void dfsa_touch_file(int);
+void dfsa_is_not_up_to_date(void);
+void dfsa_pwd_changed(void);
+int can_dfsa_file(int);
+void dfsa_syscall_on_file(int, int);
+int name_starts_in_dfsa(char **, struct nameidata *);
+int within_dfsa(struct nameidata *);
+int dfsa_optimized_read(struct file *, loff_t, unsigned long, unsigned long);
+int disable_dfsa(void);
+void enable_dfsa(void);
+
+#endif /* CONFIG_MOSIX_DFSA */
+#endif
